#
# Sensus Consulting Ltd, Copyright (c) 1997-1998
# Matt Newman <matt@sensus.org>
#
#INDEX\
proc tk++::Canvas++ {} {}

package require tk++

proc canvas++ {w args} {return [eval tk++::Canvas++ $w $args]}

class tk++::Canvas++ {
	inherit tk++::Canvas

	constructor {args} {}
	destructor {}

	public method create {type args}
	public method coords {args}
	public method delete {args}
	public method itemcget {tag option}
	public method itemconfigure {tag args}
	public method move {tag dx dy}

	public method register {type command}
	public method unregister {type command}

	private variable tags
	private variable types
}
body tk++::Canvas++::constructor {args} {
	foreach type {arc bitmap image line oval polygon rectangle text window} {
		register $type super
	}
	eval itk_initialize $args
}
body tk++::Canvas++::destructor {args} {
	foreach {tag type} [array get tags] {
		if {$types($type) != "super"} {
			catch {eval $types($type) delete $tag}
		}
	}
}
body tk++::Canvas++::coords {tag args} {
	set tag [lindex [find withtag $tag] 0]
	return [eval $types($tags($tag)) coords [list $tag] $args]
}
body tk++::Canvas++::create {type args} {
	if {![info exists types($type)]} {
		set match [array names types ${type}*]
		if {[llength $match]!=1} {
			set options [lsort [array names types]]
			set options [lreplace $options end end "or [lindex $options end]"]
			if {[llength $match]==0} {
				error "bad type \"$type\": must be one of [join $options ", "]"
			} else {
				error "ambiguous type \"$type\": must be one of [join $options ", "]"
			}
		}
		set type [lindex $match 0]
	}
	set inst $types($type)
	set tag [eval $inst create $type $args]
	set tags($tag) $type
	return $tag
}
body tk++::Canvas++::delete {args} {
	foreach tagSpec $args {
		foreach tag [find withtag $tagSpec] {
			catch {eval $types($tags($tag)) delete $tag}
		}
	}
}
body tk++::Canvas++::itemcget {tag option} {
	set tag [lindex [find withtag $tag] 0]
	return [eval $types($tags($tag)) itemcget [list $tag $option]]
}
body tk++::Canvas++::itemconfigure {tag args} {
	set tag [lindex [find withtag $tag] 0]
	return [eval $types($tags($tag)) itemconfigure [list $tag] $args]
}
body tk++::Canvas++::move {tag dx dy} {
	foreach tag [find withtag $tag] {
		eval $types($tags($tag)) coords [list $tag $dx $dy]
	}
}
body tk++::Canvas++::register {type command} {
	set types($type) $command
}
body tk++::Canvas++::unregister {type} {
	if {![info exists types($type)]} {
		error "unknown type \"$type\""
	}
	if {$types($type) == "super"} {
		error "builtin type \"$type\""
	}
	foreach {tag ttype} [array get tags] {
		if {$ttype == $type} {
			catch {eval $types($type) delete $tag}
		}
	}
	unset types($type)
}
