#
# Sensus Consulting Ltd (C) 1997
# Matt Newman <matt@sensus.org>
#
#
# return name of auto-loaded image
# Usage:
#	img folder					# find an image called folder
#
proc img {name {default ""}} {return [img::get $name $default]}

namespace eval ::img {
	variable cache
}

proc img::get {name {default ""}} {
	variable cache
	set name [namespace tail $name]
	if {[info exists cache($name)]} {
		return $cache($name)
	}
	set file [::img::find $name]
	if {$file == ""} {
		if {$default != ""} {
			set cache($name) [img::get $default]
			set cache(::img::$name) $cache($name)
			return $cache($name)
		}
		error "can't find $name"
	}

	set realname	::img::$name
	image create photo $realname -file $file

	set cache($name)		$realname
	set cache($realname)	$realname
	return $realname
}
proc img::find {name} {
	global auto_path

	foreach dir [concat . $auto_path] {
		if {[file exists $dir/images/$name.gif]} {
			return $dir/images/$name.gif
		}
		if {[file exists $dir/$name.gif]} {
			return $dir/$name.gif
		}
	}
	return ""
}
